
 package Gui125;

################################################################
###                                                          ###
### SCaFoS                                                   ###
### Affichage en mode graphique                              ###
###                                                          ###
################################################################
### Version 4.45 du 2007/07/10                           BPH ###
################################################################


 use strict;
 use warnings;

 use Cwd;

 use Tk;
 use Tk::Balloon;
 use Tk::Dialog;
 use Tk::LabFrame;
 use Tk::ROText;
 use Tk::FileSelect;

 use Var125;
 use Lib125;
 use Gub125;
 use Run125;

 use vars qw(@ISA @EXPORT);
 require Exporter;
 @ISA = qw(Exporter);
 @EXPORT = qw/ GraphicalUse /;
 

################################################################
 
 my $L;

 my $rSpe;
 my $rExt;
 my $rCat;
 my $Step;
 my $bulle;

 my $In;
 my $bIn;
 my $Out;
 my $bOut;
 my $tSpe;
 my $bSpe;
 my $tMinLen;
 my $tTax;
 my $bTax;
 my $tFrq;

 my $cChim;
 my $cDirGrp;
 my $tDirGrp;
 my $cDirSit;
 my $tDirSit;
 my $SubDir = 0;

 my $rSelDist;
 my $cGamma;
 my $tSelDist;
 my $rSelLgr;
 my $Select;
 my $tStepDir;

 my $cDefSeq;
 my $cAutoSeq;
 my $tMisPos;
 my $cTreePs;
 my $cCmp;

 my $rOnly;
 my $rLeast;
 my $rAll;
 my $File = 0;

 my $cVerb;
 my $rSpec;
 my $rAlpha;
 my $cMrB;
 my $cPAUP;
 my $cOther;
 my $cLength;
 
 my $Label10;
 my $Label11;
 my $Label20;
 my $Label21;
 my $Label22;
 my $Label30;
 my $Label40;
 my $Label41;
 my $Label42;
 my $Label50;

 my $wFile;
 my $bSelectedFile = '';

 
################################################################
# NOM : GraphicalUse
# DESCRIPTION : Initialisation de l'IHM
# PARAMETRES : so
# RETOUR : so
sub GraphicalUse {
    LoadParam();
    
    $top = MainWindow->new();
    $Scale = 1.32 / $top->scaling();
    my $Fonte = "{arial} ".sprintf("%.0f", 8*$Scale)." {bold}";

    #-- Fenetre principale -------------------------------------
    $top -> configure(-title => 'SCaFoS '.$VERSION, -bg => "#DCDCDC");
    my $f0 = $top->Frame() -> pack(-fill => 'x');
    $f0 -> configure(-bg => "#B0C4DE");
    $f0 -> Label(-text => 'SCaFos', -fg => "#4682B4", -bg => "#B0C4DE", -font => "{lucida} ".sprintf("%.0f", 32*$Scale)." {bold}", -height => 1, -width => 8, -anchor => "s")
                 -> pack(-side=>'left');
    $f0 -> Label(-text => "\nSelection, Concatenation and Fusion of Sequences",
                 -fg => "#4682B4", -bg => "#B0C4DE", -font => "{Arial} ".sprintf("%.0f", 14*$Scale)." {bold}", -width => 50, -height => 1, -anchor => "s")
                 -> pack(-side=> 'right');
    $top -> configure(-bg => "#DCDCDC");
                 
    #-- Choix de la fonction principale ------------------------
    my $f1 = $top->Frame() -> pack(-fill => 'x');
    $rSpe = $f1 -> Radiobutton(-text => 'SPECIES PRESENCE', -font => "{Arial} ".sprintf("%.0f", 12*$Scale)." {bold}",
                                  -value => 1, -variable => \$Step,
                                  -command => \&ViewWidgets);
    $rSpe -> pack(-side => 'left', -fill => 'x', -expand => 1);
    
    $rExt = $f1 -> Radiobutton(-text => 'FILE SELECTION', -font => "{Arial} ".sprintf("%.0f", 12*$Scale)." {bold}",
                                  -value => 3, -variable => \$Step,
                                  -command => \&ViewWidgets);
    $rExt -> pack(-side => 'left', -fill => 'x', -expand => 1);
    
    $rCat = $f1 -> Radiobutton(-text => 'DATASET ASSEMBLING', -font => "{Arial} ".sprintf("%.0f", 12*$Scale)." {bold}",
                                  -value => 2, -variable => \$Step,
                                  -command => \&ViewWidgets);
    $rCat -> pack(-side => 'left', -fill => 'x', -expand => 1);
    
    $f1   -> configure(-bg => "#DCDCDC");
    $rSpe -> configure(-bg => "#F0FFF0", -activebackground => "#F0FFF0", -fg => "#3CB371", -activeforeground => "#3CB371");
    $rExt -> configure(-bg => "#FAF0E6", -activebackground => "#FAF0E6", -fg => "#B22222", -activeforeground => "#B22222");
    $rCat -> configure(-bg => "#F0F8FF", -activebackground => "#F0F8FF", -fg => "#4169E1", -activeforeground => "#4169E1");
    
    $bulle = $rSpe -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rSpe , -balloonmsg => 'To create file of OTUs' , -state => 'balloon');
    $bulle = $rCat -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rCat , -balloonmsg => 'To assemble datasets' , -state => 'balloon');
    $bulle = $rExt -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rExt , -balloonmsg => 'To select sequences in aligned files' , -state => 'balloon');

    #-- Choix des repertoires et des fichiers d'entree ---------
    my $f2 = $top->Frame() -> pack(-fill => 'both');
    $In = $f2 -> Entry( -textvariable => \$FileRep, -width => 60, -font => $Fonte);
    my $bClear = $f2 -> Button ( -text => ' clear all ', -state => 'active', -command => [\&ClearAll], -font => $Fonte ); 
    $Out = $f2 -> Entry( -textvariable => \$CefRep, -width => 60, -font => $Fonte); 
    $tSpe = $f2 -> Entry( -state => 'disabled', -textvariable => \$SpecFile, -width => 60, -font => $Fonte);
    $bSpe = $f2 -> Button ( -text => 'browser', -state => 'disabled', -command => [\&SelFile, $SpecFile, $tSpe, ''], -font => $Fonte ); 
    $tMinLen = $f2 -> Entry( -state => 'disabled', -textvariable => \$MinLen, -width => 6, -font => $Fonte) -> pack(-pady => 0);
    
    $f2 -> Label( -text => ' Input directory ', -bg => "#DCDCDC", -fg => "#36648B", -font => $Fonte) 
             -> grid( -row => 0, -column => 0, -sticky => 'w');
    $In      -> grid( -row => 0, -column => 1, -sticky => 'w');
    $bClear  -> grid( -row => 0, -column => 2, -sticky => 'e');
    $f2 -> Label( -text => ' Output directory ', -bg => "#DCDCDC", -fg => "#36648B", -font => $Fonte)
             -> grid( -row => 1, -column => 0, -sticky => 'w');
    $Out     -> grid( -row => 1, -column => 1, -sticky => 'w');    
    $Label10 = $f2 -> Label (-text => ' OTUs file ', -fg => 'darkgrey', -font => $Fonte);
    $Label10 -> grid( -row => 2, -column => 0, -sticky => 'w');
    $tSpe    -> grid( -row => 2, -column => 1, -sticky => 'w');
    $bSpe    -> grid( -row => 2, -column => 2, -sticky => 'e');
    $Label11 = $f2 -> Label( -text => ' Minimal length to select a sequence (%) ', -fg => 'darkgrey', -font => $Fonte)
             -> grid( -row => 3, -column => 0, -sticky => 'w');
    $tMinLen -> grid( -row => 3, -column => 1, -sticky => 'w');

    $f2 -> configure(-bg => "#DCDCDC");
    $In -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $bClear -> configure(-bg => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $Out -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $Label10 -> configure(-bg => "#DCDCDC", -fg => "#36648B");
    $tSpe -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $bSpe -> configure(-bg => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $Label11 -> configure(-bg => "#DCDCDC", -fg => "#36648B");
    $tMinLen -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $In -> focus();
        
    $bulle = $In -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $In , -balloonmsg => 'Name of directory where the files of aligned sequences are' , -state => 'balloon');
    $bulle = $bClear -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $bClear , -balloonmsg => 'Clear all the selected options' , -state => 'balloon');
    $bulle = $Out -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $Out , -balloonmsg => 'Name of directory where the output files will be read' , -state => 'balloon');
    $bulle = $tSpe -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tSpe , -balloonmsg => 'Fullname of OTUs file (i.e. with the pathname if the file is not in the current directory)' , -state => 'balloon');
    $bulle = $bSpe -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $bSpe , -balloonmsg => 'Open a window to choose the OTUs file' , -state => 'balloon');
    $bulle = $tMinLen -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tMinLen , -balloonmsg => 'Minimal percent of the sequence length (i.e. number of characters) to take into account this sequence' , -state => 'balloon');

    #-- Creation du fichier SPE --------------------------------
    my $f6 = $top->Frame( -relief => 'sunken' , -borderwidth => 2) 
                          -> pack(-fill => 'x', -expand => 1, -padx => 5);
    $Label20 = $f6 -> Label ( -text => ' Systematic file ', -font => $Fonte);
    $Label20 -> grid( -row => 0, -column => 0, -sticky => 'w');   
    $tTax = $f6 -> Entry( -textvariable => \$NameFile, -width => 60, -font => $Fonte);
    $tTax -> grid ( -row => 0, -column => 2, -sticky => 'w');
    $bTax = $f6 -> Button( -text => 'browser', -state => 'active', -command => [\&SelFile, $NameFile, $tTax, ''], -font => $Fonte);
    $bTax -> grid ( -row => 0, -column => 3, -sticky => 'e');
    $Label21 = $f6 -> Label ( -text => ' Minimum frequency of species ', -font => $Fonte);
    $Label21 -> grid ( -row => 1, -column => 0, -sticky => 'w');
    $Label22 = $f6 -> Label( -text => '[0, 100] ', -font => $Fonte);
    $Label22 -> grid ( -row => 1, -column => 1, -sticky => 'e');
    $tFrq = $f6 -> Entry( -textvariable => \$TauxMin, -width => 6, -font => $Fonte);
    $tFrq -> grid ( -row => 1, -column =>2, -sticky => 'w');

    $f6 -> configure(-bg => "#DCDCDC");
    $Label20 -> configure(-bg => "#DCDCDC", -fg => "#3CB371");
    $Label21 -> configure(-bg => "#DCDCDC", -fg => "#3CB371");
    $Label22 -> configure(-bg => "#DCDCDC", -fg => "#3CB371");
    $tTax -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $bTax -> configure(-bg => "#DCDCDC", -fg => "#3CB371", -activeforeground => "#3CB371");
    $tFrq -> configure(-bg => "#F8F8FF", -fg => "#003F87");
        
    $bulle = $tTax -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tTax , -balloonmsg => 'Fullname of systematic file (i.e. with the pathname if the file is not in the current directory) used to classify the species' , -state => 'balloon');
    $bulle = $bTax -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $bTax , -balloonmsg => 'Open a window to choose the systematic file' , -state => 'balloon');
    $bulle = $tFrq -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tFrq , -balloonmsg => 'Minimal percent of frequence among all aligned files to include a species in the new OTUs file' , -state => 'balloon');
    
    #-- Extraction ---------------------------------------------
    my $f20 = $top->Frame( -relief => 'sunken' , -borderwidth => 2) 
                           -> pack(-side => 'top', -fill => 'x', -expand => 1, -padx => 5);
    $rOnly = $f20  -> Radiobutton(-text => 'Create files with ONLY selected species  ', -anchor => 'w',
                                  -variable => \$File, -value => 1, -font => $Fonte);
    $rLeast = $f20 -> Radiobutton(-text => 'Select files with AT LEAST ONE selected species ', -anchor => 'w',
                                  -variable => \$File, -value => 2, -font => $Fonte);
    $rAll = $f20 -> Radiobutton(-text => 'Select files with ALL OTUs ', -anchor => 'w', 
                                -variable => \$File, -value => 3, -font => $Fonte);
    $rOnly -> grid ( -row => 0, -column => 0, -sticky => 'w');
    $rLeast -> grid( -row => 1, -column => 0, -sticky => 'w' );
    $rAll -> grid  ( -row => 2, -column => 0, -sticky => 'w');
    $rOnly -> configure(-state => 'disabled');
    $rLeast -> configure(-state => 'disabled');
    $rAll -> configure(-state => 'disabled');

    $f20 -> configure(-bg => "#DCDCDC");
    $rOnly -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#B22222", -activeforeground => "#B22222");
    $rLeast -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#B22222", -activeforeground => "#B22222");
    $rAll -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#B22222", -activeforeground => "#B22222");
    
    $bulle = $rOnly -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rOnly , -balloonmsg => 'Creates new aligned files containing ONLY the sequences of the species included in the OTUs file' , -state => 'balloon');
    $bulle = $rLeast -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rLeast , -balloonmsg => 'Selects aligned files contained AT LEAST one species included in the OTUs file' , -state => 'balloon');
    $bulle = $rAll -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rAll , -balloonmsg => 'Selects aligned files contained at least one species for ALL OTUs defined in the OTUs file' , -state => 'balloon');
        
    #-- Concatenation ------------------------------------------
    my $f10 = $top->Frame( -relief => 'sunken' , -borderwidth => 2) 
                           -> pack(-side => 'top', -fill => 'x', -expand => 1, -padx => 5);
    $f10 -> configure(-bg => "#DCDCDC");
    
    #-- Chimeres ----
    my $f11 = $f10->Frame() -> pack(-fill => 'both', -side => 'top');
    $cChim = $f11 -> Checkbutton(-text => 'Making of Chimera', -variable => \$FlagChim, -font => $Fonte);
    $cChim -> grid( -row => 0, -column => 0, -sticky => 'w'); 
    $cChim -> configure(-state => 'disabled');
    $f11 -> configure(-bg => "#DCDCDC");
    $cChim -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $bulle = $cChim -> Balloon( -fg => "#800080", -bg => "#F5F5F5" );
    $bulle -> attach ( $cChim , -balloonmsg => 'If checked, makes CHIMERA with sequences IN ONE OTU' , -state => 'balloon');
    
    #-- Options de selection des sequences ---
    my $f12 = $f10 -> LabFrame( -label => ' Criteria to choose sequence within an OTU ', -fg => "#36648B", -font => $Fonte) 
                             -> pack(-fill => 'both', -side => 'top', -padx => 60);
    $rSelDist = $f12 -> Radiobutton( -text => 'Minimal evolutionary distance (Tree-Puzzle)   ',
                                     -value => 1, -variable => \$Select,
                                     -command => [\&ActiveSaisieDist, 1], -font => $Fonte);
    $rSelLgr = $f12 -> Radiobutton( -text => 'Longer sequence ',
                                    -value => 2, -variable => \$Select, 
                                    -command => [\&ActiveSaisieDist, 2], -font => $Fonte);
    $cGamma = $f12 -> Checkbutton( -text => 'With Gamma    ', 
                                   -state => 'disabled', -variable => \$FlagGamma, -font => $Fonte); 
    $Label30 = $f12 -> Label( -text => 'Threshold [>= 0%]', -font => $Fonte);
    $tSelDist = $f12 -> Entry(-state => 'disabled', -textvariable => \$PctAve, -width => 6, -font => $Fonte); 
    $f12 -> Label( -text => '  ', -bg => "#DCDCDC") ->  grid ( -row => 2, -column => 0, -sticky => 'w'); 
    $cRemoveAll = $f12 -> Checkbutton( -text => 'Remove file when at least one OTU is too divergent', -variable => \$FlagRemoveAll, -font => $Fonte);
    $f12 -> Label( -text => '  ', -bg => "#DCDCDC", -font => $Fonte) ->  grid ( -row => 2, -column => 0, -sticky => 'w'); 
    $cDefSeq = $f12 -> Checkbutton( -text => 'Using DEFAULT sequence for an OTU   ', -variable => \$FlagDef, 
                                    -command => [\&ActiveSaisieDef, $FlagDef], -font => $Fonte);
    $f12 -> Label( -text => '  ', -bg => "#DCDCDC", -font => $Fonte) ->  grid ( -row => 3, -column => 0, -sticky => 'w'); 
    $cAutoSeq = $f12 -> Checkbutton( -text => 'With automatic choise by SCaFos', 
                                     -state => 'disabled', -variable => \$FlagDefAuto, -font => $Fonte);
    
    $rSelDist   -> grid( -row => 1, -column => 0, -sticky => 'w', -columnspan => 2 );
    $cGamma     -> grid( -row => 1, -column => 2, -sticky => 'e' );
    $Label30    -> grid( -row => 1, -column => 3, -sticky => 'e' );
    $tSelDist   -> grid( -row => 1, -column => 4, -sticky => 'w' );
    $cDefSeq    -> grid( -row => 2, -column => 1, -sticky => 'w');
    $cAutoSeq   -> grid( -row => 2, -column => 2, -sticky => 'w', -columnspan => 2 );
    $cRemoveAll -> grid( -row => 3, -column => 1, -sticky => 'w', -columnspan => 2 );
    $rSelLgr    -> grid( -row => 5, -column => 0, -sticky => 'w', -columnspan => 2 );

    $bulle = $rSelDist -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rSelDist , -balloonmsg => 'Selection of the best sequence according to the less divergent sequence witin the OTU' , -state => 'balloon');
    $bulle = $cGamma -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cGamma , -balloonmsg => 'If checked, uses 4 gamma categories to calculate evolutionary distances with TREE-PUZZLE' , -state => 'balloon');
    $bulle = $tSelDist -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tSelDist , -balloonmsg => 'Threshold used to elliminate sequences too divergent (i.e. potential paralogous)' , -state => 'balloon');
    $bulle = $cRemoveAll -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cRemoveAll , -balloonmsg => 'If checked, remove completely a file from the final dataset when at least one OTU have sequence(s) too divergent' , -state => 'balloon');
    $bulle = $cDefSeq -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cDefSeq , -balloonmsg => 'If checked, creates  or uses  default sequence files' , -state => 'balloon');
    $bulle = $cAutoSeq -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cAutoSeq , -balloonmsg => 'If checked, let choose automatically the best sequence if no previous selection in the corresponding default file' , -state => 'balloon');
    $bulle = $rSelLgr -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rSelLgr , -balloonmsg => 'Selection of the best sequence according to the longer sequence' , -state => 'balloon');
        
    $rSelDist -> configure( -state => 'disabled');
    $Label30 -> configure( -fg => 'darkgrey');
    $PctAve = 25;
    $tSelDist -> configure( -state => 'disabled', -textvariable => \$PctAve);
    $cRemoveAll -> configure( -state => 'disabled');
    $cDefSeq -> configure( -state => 'disabled');
    $cAutoSeq -> configure( -state => 'disabled');
    $rSelLgr -> configure( -state => 'disabled');
    
    $f12 -> configure(-bg => "#DCDCDC");
    $rSelDist -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $cGamma -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $Label30 -> configure(-bg => "#DCDCDC", -fg => "#4169E1");
    $tSelDist -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $cDefSeq -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $cAutoSeq -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $cRemoveAll -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $rSelLgr -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");

    #-- Extraction dans sous-repertoires ---
    my $f13 = $f10 -> LabFrame( -label => ' Create subdirectories with ', -fg => "#36648B", -font => $Fonte)
                                -> pack(-fill => 'both', -side => 'top', -padx => 60);
    $cDirGrp  = $f13 -> Checkbutton( -text => 'Maximum number of missing OTUs ',
                                     -variable => \$FlagMisGrp,
                                     -command => [\&ActiveSaisieSub, 1], -font => $Fonte);
    $tDirGrp = $f13 -> Entry(-state => 'disabled', -textvariable => \$NbMisGrp, -width => 6, -font => $Fonte);
    $cDirSit  = $f13 -> Checkbutton( -text => 'Maximum percent of missing sites ',
                                     -variable => \$FlagMisSit,
                                     -command => [\&ActiveSaisieSub, 2], -font => $Fonte);
    $Label40 = $f13 -> Label( -text => '[0, 50] ', -font => $Fonte);
    $tDirSit = $f13 -> Entry(-state => 'disabled', -textvariable => \$PctMisSit, -width => 6, -font => $Fonte);
    $Label41 = $f13 -> Label( -text => 'Step to create subdirectory', -font => $Fonte);
# 4.45    $PctMisSit = 20;
    my $buf = "[0, $PctMisSit] ";
    $Label42 = $f13 -> Label( -text => $buf, -font => $Fonte);
    $tDirSit -> bind ( "<FocusOut>" , \&MajLabel42 ) ;
    $tStepDir = $f13 -> Entry(-state => 'disabled', -textvariable => \$PasMisSit, -width => 6, -font => $Fonte);

    $cDirGrp -> grid ( -row => 0, -column => 0, -sticky => 'w');
    $tDirGrp -> grid ( -row => 0, -column => 2, -sticky => 'e');
    $cDirSit -> grid ( -row => 1, -column => 0, -sticky => 'w');
    $Label40 -> grid ( -row => 1, -column => 1, -sticky => 'e');
    $tDirSit -> grid ( -row => 1, -column => 2, -sticky => 'e');
    $Label41 -> grid ( -row => 2, -column => 0, -sticky => 'e');
    $Label42 -> grid ( -row => 2, -column => 1, -sticky => 'e');
    $tStepDir -> grid( -row => 2, -column => 2, -sticky => 'e');
         
    $bulle = $cDirGrp -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cDirGrp , -balloonmsg => 'If checked, creates subdirectories according to the number of missing OTUs in aligned files' , -state => 'balloon');
    $bulle = $tDirGrp -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tDirGrp , -balloonmsg => 'Maximal number of missing OTUs authorized' , -state => 'balloon');
    $bulle = $cDirSit -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cDirSit , -balloonmsg => 'If checked, creates subdirectories according to the percent of missing positions in aligned files' , -state => 'balloon');
    $bulle = $tDirSit -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tDirSit , -balloonmsg => 'Maximal percent of missing positions authorized' , -state => 'balloon');
    $bulle = $tStepDir -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tStepDir , -balloonmsg => 'Step used to increment the percentage of missing positions' , -state => 'balloon');
    
    $cDirGrp -> configure(-state => 'disabled');
    $cDirSit -> configure(-state => 'disabled');
    $Label40 -> configure(-fg => 'darkgrey');
    $tDirSit -> configure(-state => 'disabled');
    $Label41 -> configure(-fg => 'darkgrey');
    $Label42 -> configure(-fg => 'darkgrey');
    $tStepDir -> configure(-state => 'disabled');
    
    $f13 -> configure(-bg => "#DCDCDC");
    $cDirGrp -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $tDirGrp -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $cDirSit -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $Label40 -> configure(-bg => "#DCDCDC");
    $tDirSit -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $Label41 -> configure(-bg => "#DCDCDC");
    $Label42 -> configure(-bg => "#DCDCDC");
    $tStepDir -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    
    #-- Autres options ---
    my $f14 = $f10 -> LabFrame( -label => ' Others options ', -fg => "#36648B", -font => $Fonte) 
                                -> pack(-fill => 'both', -side => 'top', -padx => 60); 
    $Label50 = $f14 -> Label( -text => 'Maximal percent of missing sites corresponding to \'complete sequence\'', -font => $Fonte);
    $tMisPos = $f14 -> Entry( -textvariable => \$MissPos, -width => 6, -font => $Fonte);
    $cTreePs = $f14 -> Checkbutton( -text => 'Tree in postscript format colored according selected sequence',
                                    -variable => \$FlagColor, -font => $Fonte);
    $cCmp = $f14 -> Checkbutton( -text => 'Determine variation in the sequence composition',
                                 -variable => \$FlagCmp, -font => $Fonte);
    
    $f14 -> Label( -text => '    ', -bg => "#DCDCDC") -> grid( -row => 1, -column => 0, -sticky => 'w' ); 
    $Label50                        -> grid( -row => 1, -column => 1, -sticky => 'w' );
    $tMisPos                        -> grid( -row => 1, -column => 2, -sticky => 'w' );
    $f14 -> Label( -text => '    ', -bg => "#DCDCDC") -> grid( -row => 2, -column => 0, -sticky => 'w' ); 
    $cTreePs                        -> grid( -row => 2, -column => 1, -sticky => 'w' );
    $f14 -> Label( -text => '    ', -bg => "#DCDCDC") -> grid( -row => 3, -column => 0, -sticky => 'w' ); 
    $cCmp                           -> grid( -row => 3, -column => 1, -sticky => 'w' );
    $Label50 -> configure(-fg => 'darkgrey');
    $tMisPos -> configure(-state => 'disabled');
    $cTreePs -> configure(-state => 'disabled');
    $cCmp -> configure(-state => 'disabled');

    $f14 -> configure(-bg => "#DCDCDC");
    $Label50 -> configure(-bg => "#DCDCDC");
    $tMisPos -> configure(-bg => "#F8F8FF", -fg => "#003F87");
    $cTreePs -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");
    $cCmp -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#4169E1", -activeforeground => "#4169E1");

    $bulle = $tMisPos -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $tMisPos , -balloonmsg => 'Maximal percent of missing potions authorized to consider a sequence as a complete sequence (i.e. not used to create a chimera)' , -state => 'balloon');
    $bulle = $cTreePs -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cTreePs , -balloonmsg => 'If checked, modifies the tree postscript files according to the selection of the sequences or the creation of chimera' , -state => 'balloon');
    $bulle = $cCmp -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cCmp , -balloonmsg => 'If checked, Determine the composition in amino acids or nucleotids for each sequence and estimate the variation with the mean composition of the gene' , -state => 'balloon');
    
    #-- Common options -----------------------------------------
    my $f30 = $top -> Frame() -> pack( -side => 'top', -fill => 'both', -expand => 1, -padx => 5); #, -pady => 1);
    my $f31 = $f30 -> Frame( -relief => 'sunken' , -borderwidth => 2)
                             -> pack( -side => 'left' );
    $cVerb = $f31 -> Checkbutton( -text => 'Verbose', -variable => \$FlagVerb, -font => $Fonte);
    $cVerb -> pack( -side => 'top', -padx => 40, -pady => 33);
    $f30 -> configure(-bg => "#DCDCDC");
    $f31 -> configure(-bg => "#DCDCDC");
    $cVerb -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $bulle = $cVerb -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cVerb , -balloonmsg => 'If checked, displays more details to describe the processing of the program' , -state => 'balloon');
    
    #-- Output format ------------------------------------------
    my $f32 = $f30 -> Frame( -relief => 'sunken' , -borderwidth => 2) 
                             -> pack(-side => 'left', -fill => 'both', -expand => 1);
    my $Label60 = $f32 -> Label( -text => 'Output order :', -font => $Fonte );
    $rSpec = $f32 -> Radiobutton(-text => 'OTU file  ', -anchor => 'w',
                                  -variable => \$FlagAlphabet, -value => 0, -font => $Fonte);
    $rAlpha = $f32 -> Radiobutton(-text => 'Alphabetic  ', -anchor => 'w',
                                  -variable => \$FlagAlphabet, -value => 1, -font => $Fonte);
    my $Label61 = $f32 -> Label( -text => 'Output formats :', -font => $Fonte);
    $cFasta = $f32 ->  Checkbutton( -text => 'FASTA    ',        -variable => \$FlagFasta, -font => $Fonte);
    $cMust = $f32 ->   Checkbutton( -text => 'MUST    ',         -variable => \$FlagMust, -font => $Fonte);
    $cPHYLIP = $f32 -> Checkbutton( -text => 'PHYLIP    ',       -variable => \$FlagPHYLIP, -font => $Fonte);
    $cNexus = $f32 ->  Checkbutton( -text => 'NEXUS    ',        -variable => \$FlagNexus, -font => $Fonte);
    $cMrB = $f32 ->    Checkbutton( -text => 'for Mr Bayes    ', -variable => \$FlagMB, -font => $Fonte);
    $cPAUP = $f32 ->   Checkbutton( -text => 'for PAUP    ',     -variable => \$FlagPAUP, -font => $Fonte);
    $cOther = $f32 ->  Checkbutton( -text => 'for other    ',    -variable => \$FlagOther, -font => $Fonte);
    $cLength = $f32 -> Checkbutton( -text => 'Add number of characters to the OTU name', -variable => \$FlagLength, -font => $Fonte);
    
    $Label60 -> grid( -row => 0, -column => 0, -sticky => 'w', -padx => 20);
    $rSpec   -> grid( -row => 0, -column => 1, -sticky => 'w');
    $rAlpha  -> grid( -row => 0, -column => 2, -sticky => 'w' );
    $Label61 -> grid( -row => 1, -column => 0, -sticky => 'w', -padx => 20);
    $cFasta  -> grid( -row => 1, -column => 1, -sticky => 'w');
    $cMust   -> grid( -row => 1, -column => 2, -sticky => 'w');
    $cPHYLIP -> grid( -row => 1, -column => 3, -sticky => 'w');
    $cNexus  -> grid( -row => 2, -column => 1, -sticky => 'w');
    $cMrB    -> grid( -row => 2, -column => 2, -sticky => 'w');
    $cPAUP   -> grid( -row => 2, -column => 3, -sticky => 'w');
    $cOther  -> grid( -row => 2, -column => 4, -sticky => 'w');
    $cLength -> grid( -row => 3, -column => 0, -sticky => 'w', -columnspan => 5, -padx => 20);
    
    $rSpec -> configure( -state => 'disable' );
    $rAlpha -> configure( -state => 'disable' );
    $cFasta -> configure( -state => 'disable' );
    $cMust -> configure( -state => 'disable' );
    $cPHYLIP -> configure( -state => 'disable' );
    $cNexus -> configure( -state => 'disable' );
    $cMrB -> configure( -state => 'disable' );
    $cPAUP -> configure( -state => 'disable' );
    $cOther -> configure( -state => 'disable' );
    $cLength -> configure( -state => 'disable' );
    
    $f32 -> configure(-bg => "#DCDCDC");
    $Label60 -> configure(-bg => "#DCDCDC", -fg => "#36648B");
    $rSpec -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $rAlpha -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $Label61 -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B");
    $cFasta -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cMust -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cPHYLIP -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cNexus -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cMrB -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cPAUP -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cOther -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    $cLength -> configure(-bg => "#DCDCDC", -activebackground => "#DCDCDC", -fg => "#36648B", -activeforeground => "#36648B");
    
    $bulle = $rSpec -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rSpec , -balloonmsg => 'Output files are sorted according the order defined in the OTUs file' , -state => 'balloon');
    $bulle = $rAlpha -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $rAlpha , -balloonmsg => 'Output files are sorted according the alphabetic order' , -state => 'balloon');
    $bulle = $cFasta -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cFasta , -balloonmsg => 'Output files are writen in the FASTA format' , -state => 'balloon');
    $bulle = $cMust -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cMust , -balloonmsg => 'Output files are writen in the MUST format' , -state => 'balloon');
    $bulle = $cPHYLIP -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cPHYLIP , -balloonmsg => 'Output files are writen in the PHYLIP format' , -state => 'balloon');
    $bulle = $cNexus -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cNexus , -balloonmsg => 'Output files are writen in the NEXUS format' , -state => 'balloon');
    $bulle = $cMrB -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cMrB , -balloonmsg => 'If checked, commands for MrBayes are added in the Nexus file' , -state => 'balloon');
    $bulle = $cPAUP -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cPAUP , -balloonmsg => 'If checked, commands for PAUP are added in the Nexus file' , -state => 'balloon');
    $bulle = $cOther -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cOther , -balloonmsg => 'If checked, a new window is opened to add commands in the Nexus file' , -state => 'balloon');
    $bulle = $cLength -> Balloon( -fg => "#800080", -bg => "#F5F5F5", -font => $Fonte );
    $bulle -> attach ( $cLength , -balloonmsg => 'If checked, adds the number of characters in the concatenated sequence to the OTU\'s name in files creates in the subdirectories' , -state => 'balloon');
    
    #-- Lancement, aide et sortie ------------------------------
    my $f40 = $top->Frame() -> pack(-side => 'top', -fill => 'both', -expand => 1);
    $f40 -> Button ( -text => ' HELP ', -command => \&ViewHelp, -fg => "#228B22", -activeforeground => "#228B22", -font => "{Arial} 12 {bold}") 
                     -> pack(-side => 'left', -fill => 'x', -expand => 1);
    $f40 -> Button ( -text => ' RUN ', -command => \&CheckParam, -fg => 'blue', -activeforeground => 'blue', -font => "{Arial} 12 {bold}") 
                     -> pack(-side => 'left', -fill => 'x', -expand => 1);
    $f40 -> Button ( -text => ' QUIT ', -command => \&QuitSCaFoS, -fg => 'red', -activeforeground => 'red', -font => "{Arial} 12 {bold}") 
                     -> pack(-side => 'right', -fill => 'x', -expand => 1);
    $f40 -> configure(-bg => "#DCDCDC");

    $FenCur = $top;

    ViewWidgets();
    
    MainLoop();

}    

sub ClearAll {
    #-- Option principale ---
    $Step = 1;
    #-- Choix des repertoires et des fichiers d'entree ---
    $FileRep = '';
    $CefRep = '';
    $SpecFile = '';
    $MinLen = 10;
    #-- Creation du fichier SPE ---
    $NameFile = '';
    $TauxMin = 0;
    #-- Extraction ---
    $File = 1;
    #-- Concatenation ---
    # Chimeres
    $FlagChim = 0;
    # Options de selection des sequences
    $Select = 1;
    $FlagGamma = 0;
    $PctAve = 25;
    $FlagDef = 0;
    $FlagDefAuto = 0;
    $FlagRemoveAll = 0;
    # Extraction dans sous-repertoires
    $FlagMisGrp = 0;
    $NbMisGrp = 25;
    $FlagMisSit = 0;
    $PctMisSit = 20;
    $PasMisSit = 5;
    # Autres options
    $MissPos = 10;
    $FlagColor = 0;
    $FlagCmp = 0;
    # Output format
    $FlagAlphabet = 0;
    $FlagFasta = 1;
    $FlagMust = 0;
    $FlagPHYLIP = 0;
    $FlagNexus = 0;
    $FlagMB = 0;
    $FlagPAUP = 0;
    $FlagOther = 0;
    $FlagLength = 0;
    #-- Common options ---
    $FlagVerb = 0;
}

sub QuitSCaFoS {
    #-- Ecriture du fichier scafos.par -------------------------
    my $buf = "# Last options selected for SCaFoS (graphical use only)\n\n";
    $buf .= "MAIN_OPTION = $Step;\n";
    #-- Choix des repertoires et des fichiers d'entree ---
    $buf .= "DIR_IN = $FileRep;\n";
    $buf .= "DIR_OUT = $CefRep;\n";
    $buf .= "FILE_OTU = $SpecFile;\n";
    $buf .= "MIN_LEN = $MinLen;\n\n";
    #-- Creation du fichier SPE ---
    $buf .= "FILE_TAXA = $NameFile;\n";
    $buf .= "MIN_FREQ = $TauxMin;\n\n";
    #-- Extraction ---
    $buf .= "EXTRACT = $File;\n\n";
    #-- Concatenation ---
    # Chimeres
    $buf .= "FLAG_CHIM = $FlagChim;\n\n";
    # Options de selection des sequences
    $buf .= "TYPE_SEL = $Select;\n";
    $buf .= "FLAG_GAMMA = $FlagGamma;\n";
    $buf .= "THRESHOLD = $PctAve;\n";
    $buf .= "FLAG_DEF = $FlagDef;\n";
    $buf .= "FLAG_DEF_AUTO = $FlagDefAuto;\n";
    $buf .= "FLAG_RM_ALL = $FlagRemoveAll;\n\n";
    # Extraction dans sous-repertoires
    $buf .= "FLAG_MIS_GRP = $FlagMisGrp;\n";
    $buf .= "NB_MIS_GRP = $NbMisGrp;\n";
    $buf .= "FLAG_MIS_SIT = $FlagMisSit;\n";
    $buf .= "PCT_MIS_SIT = $PctMisSit;\n";
    $buf .= "STEP_MIS_SIT = $PasMisSit;\n\n";
    # Autres options
    $buf .= "COMPL_SEQ = $MissPos;\n";
    $buf .= "FLAG_COLOR = $FlagColor;\n";
    $buf .= "FLAG_CMP = $FlagCmp;\n\n";
    # Output format
    $buf .= "ORDER_OUT = $FlagAlphabet;\n";
    $buf .= "FLAG_FASTA = $FlagFasta;\n";
    $buf .= "FLAG_MUST = $FlagMust;\n";
    $buf .= "FLAG_PHYLIP = $FlagPHYLIP;\n";
    $buf .= "FLAG_NEXUS = $FlagNexus;\n";
    $buf .= "FLAG_MB = $FlagMB;\n";
    $buf .= "FLAG_PAUP = $FlagPAUP;\n";
    $buf .= "FLAG_OTHER = $FlagOther;\n";
    $buf .= "FLAG_ADD_LG = $FlagLength;\n\n";
    #-- Common options ---
    $buf .= "FLAG_VERB = $FlagVerb;\n";
    
#441    if ( !(open FIC, '> '.$ENV{SCAFOS}.'/scafosmod/scafos.par') ) 
#        { AffError("Can't open for writing file \'".$ENV{SCAFOS}."/scafosmod/scafos.par\'"); } 
    if ( !(open FIC, '> scafos.par') ) 
        { AffError("Can't open for writing file \'scafos.par\'"); } 
    print FIC $buf;
    close FIC;
    
    exit(0);
}

sub LoadParam {
    my $buf;
    
#441    $buf = $ENV{SCAFOS}.'/scafosmod/scafos.par';
    $buf = 'scafos.par';
    if ( open FIC, $buf ) {   
        $Step = 1;
        $Select = 1;
        $PctAve = 25;
        $PctMisSit = 20;

        $buf = '';
        while ( $buf = <FIC> ) {
            $buf =~ s/^\s+//;
            $buf =~ s/\s+$//;
            if ( $buf =~ m/^#/ ) { next; }
            if ( length($buf) == 0 ) { next; }

            #-- Choix de la fonction principale ------------------------
            if ( $buf =~ m/^MAIN_OPTION\s*=\s*(1|2|3);/ ) { $Step = int($1); }

            #-- Choix des repertoires et des fichiers d'entree ---------
            if ( $buf =~ m/^DIR_IN\s*=\s*(.+);/ ) { $FileRep = $1; $FileRep =~ s/^\s+//; $FileRep =~ s/\s+$//; }
            if ( $buf =~ m/^DIR_OUT\s*=\s*(.+);/ ) { $CefRep = $1; $CefRep =~ s/^\s+//; $CefRep =~ s/\s+$//; }
            if ( $buf =~ m/^FILE_OTU\s*=\s*(.+);/ ) { $SpecFile = $1; $SpecFile =~ s/^\s+//; $SpecFile =~ s/\s+$//; }
            if ( $buf =~ m/^MIN_LEN\s*=\s*(\d+);/ ) { $MinLen = int($1); }

            #-- Creation du fichier SPE --------------------------------
            if ( $buf =~ m/^FILE_TAXA\s*=\s*(.+);/ ) { $NameFile = $1; $NameFile =~ s/^\s+//; $NameFile =~ s/\s+$//; }
            if ( $buf =~ m/^MIN_FREQ\s*=\s*(\d+);/ ) { $TauxMin = int($1); }

            #-- Extraction ---------------------------------------------
            if ( $buf =~ m/^EXTRACT\s*=\s*(1|2|3);/ ) { $File = int($1); }

            #-- Concatenation ------------------------------------------
            #-- Chimeres ----
            if ( $buf =~ m/^FLAG_CHIM\s*=\s*(0|1);/ ) { $FlagChim = int($1); }
            #-- Options de selection des sequences ---
            if ( $buf =~ m/^TYPE_SEL\s*=\s*(1|2);/ ) { $Select = int($1); }
            if ( $buf =~ m/^FLAG_GAMMA\s*=\s*(0|1);/ ) { $FlagGamma = int($1); }
            if ( $buf =~ m/^THRESHOLD\s*=\s*(\d+);/ ) { $PctAve = int($1); }
            if ( $buf =~ m/^FLAG_DEF\s*=\s*(0|1);/ ) { $FlagDef = int($1); }
            if ( $buf =~ m/^FLAG_DEF_AUTO\s*=\s*(0|1);/ ) { $FlagDefAuto = int($1); }
            if ( $buf =~ m/^FLAG_RM_ALL\s*=\s*(0|1);/ ) { $FlagRemoveAll = int($1); }
            #-- Extraction dans sous-repertoires ---
            if ( $buf =~ m/^FLAG_MIS_GRP\s*=\s*(0|1);/ ) { $FlagMisGrp = int($1); }
            if ( $buf =~ m/^NB_MIS_GRP\s*=\s*(\d+);/ ) { $NbMisGrp = int($1); }
            if ( $buf =~ m/^FLAG_MIS_SIT\s*=\s*(0|1);/ ) { $FlagMisSit = int($1); }
            if ( $buf =~ m/^PCT_MIS_SIT\s*=\s*(\d+);/ ) { $PctMisSit = int($1); }
            if ( $buf =~ m/^STEP_MIS_SIT\s*=\s*(\d+);/ ) { $PasMisSit = int($1); }
            #-- Autres options ---
            if ( $buf =~ m/^COMPL_SEQ\s*=\s*(\d+);/ ) { $MissPos = int($1); }
            if ( $buf =~ m/^FLAG_COLOR\s*=\s*(0|1);/ ) { $FlagColor = int($1); }
            if ( $buf =~ m/^FLAG_CMP\s*=\s*(0|1);/ ) { $FlagCmp = int($1); }
            #-- Output format ---
            if ( $buf =~ m/^ORDER_OUT\s*=\s*(0|1);/ ) { $FlagAlphabet = int($1); }
            if ( $buf =~ m/^FLAG_FASTA\s*=\s*(0|1);/ ) { $FlagFasta = int($1); }
            if ( $buf =~ m/^FLAG_MUST\s*=\s*(0|1);/ ) { $FlagMust = int($1); }
            if ( $buf =~ m/^FLAG_PHYLIP\s*=\s*(0|1);/ ) { $FlagPHYLIP = int($1); }
            if ( $buf =~ m/^FLAG_NEXUS\s*=\s*(0|1);/ ) { $FlagNexus = int($1); }
            if ( $buf =~ m/^FLAG_MB\s*=\s*(0|1);/ ) { $FlagMB = int($1); }
            if ( $buf =~ m/^FLAG_PAUP\s*=\s*(0|1);/ ) { $FlagPAUP = int($1); }
            if ( $buf =~ m/^FLAG_OTHER\s*=\s*(0|1);/ ) { $FlagOther = int($1); }
            if ( $buf =~ m/^FLAG_ADD_LG\s*=\s*(0|1);/ ) { $FlagLength = int($1); }

            #-- Common options -----------------------------------------
            if ( $buf =~ m/^FLAG_VERB\s*=\s*(0|1);/ ) { $FlagVerb = int($1); }
            }    
        close FIC;
        }
    else
        { ClearAll(); }
}


sub MajLabel42 {
    $Label42 -> configure(-text => "[0, $PctMisSit] ");
}


### Selection de fichiers ######################################
sub SelFile {
    my ($tFile, $eFile, $flag) = @_;       # controle ou ecrire le nom du fichier selectionne
    if ( Exists($wFile) ) { $wFile->destroy(); }
    my $StartDir = '.';
    if ( $flag eq '-d' )
        { $wFile = $top->toplevel->FileSelect(-directory => $StartDir, -verify => [qw/-d/]); }
    else
        { $wFile = $top->toplevel->FileSelect(-directory => $StartDir); }
    my $file = $wFile->Show;
    
    $wFile -> configure(-command => \&SaveSelectFile($file));
    $tFile = $bSelectedFile;
    $eFile -> configure( -text => $tFile );
}

sub SaveSelectFile {
    $bSelectedFile = $_[0] || '';
}


### Selection de repertoires ###################################
sub SelDir {
    my ($eDir, $flag) = @_;       # controle ou ecrire le nom du repertoire
    my $tDir = '';
    
    $tDir = $top->chooseDirectory(-initialdir => '.', -parent => $top, -title => ' Choose a directory', -fg => "#36648B");
    if ( $tDir ) {
        $eDir -> configure( -text => $tDir );
        if ( $flag == 1 ) { $FileRep = $tDir; }
        else              { $CefRep = $tDir; }
        }
}


### Visualisation des controles selon les options choisies par l'utilisateur ##
sub ViewWidgets {
    if ( $Step == 1 ) {
        #-- fichier d'especes --- 
        $SpecFile = "";
        $Label10 -> configure(-fg => 'darkgrey');
        $tSpe -> configure(-state => 'disabled', -textvariable => \$SpecFile);
        $MinLen = "0";
        $Label11 -> configure(-fg => 'darkgrey');
        $tMinLen -> configure(-state => 'disabled', -textvariable => \$MinLen);
        $bSpe -> configure(-state => 'disabled');
        $Label20 -> configure(-fg => "#3CB371");
        $Label21 -> configure(-fg => "#3CB371");
        $Label22 -> configure(-fg => "#3CB371");
        $tTax -> configure(-state => 'normal');
        $bTax -> configure(-state => 'active', -bg => "#DCDCDC");
        $tFrq -> configure(-state => 'normal');
        #-- concatenation ---
        $cChim -> configure(-state => 'disabled');
        $rSelDist -> configure( -state => 'disabled');
        $rSelLgr -> configure( -state => 'disabled');
        ActiveSaisieDist(2);
        $cDirGrp -> configure(-state => 'disabled');
        $cDirSit -> configure(-state => 'disabled');
        ActiveSaisieSub(0);
        $Label50 -> configure(-fg => 'darkgrey');
        $tMisPos -> configure(-state => 'disabled');
        $cTreePs -> configure(-state => 'disabled');
        $cCmp -> configure(-state => 'disabled');
        #-- extraction ---     
        $rOnly -> configure(-state => 'disabled');
        $rLeast -> configure(-state => 'disabled');
        $rAll -> configure(-state => 'disabled');
        #-- format de sortie ---
        $rSpec-> configure( -state => 'disabled' );        
        $rAlpha-> configure( -state => 'disabled' );
        $FlagAlphabet = 1;        
        $cFasta-> configure( -state => 'disabled' );  
        $FlagFasta = 0;
        $cFasta-> configure( -variable => \$FlagFasta );
        $cMust-> configure( -state => 'disabled' );
        $FlagMust = 0;
        $cMust-> configure( -variable => \$FlagMust );
        $cPHYLIP-> configure( -state => 'disabled' );        
        $FlagPHYLIP = 0;
        $cPHYLIP-> configure( -variable => \$FlagPHYLIP );
        $cNexus-> configure( -state => 'disabled' );        
        $FlagNexus = 0;
        $cNexus-> configure( -variable => \$FlagNexus );
        $cMrB-> configure( -state => 'disabled' );        
        $FlagMB = 0;
        $cMrB-> configure( -variable => \$FlagMB );
        $cPAUP-> configure( -state => 'disabled' );        
        $FlagPAUP = 0;
        $cPAUP-> configure( -variable => \$FlagPAUP );
        $cOther-> configure( -state => 'disabled' );        
        $FlagOther = 0;
        $cOther-> configure( -variable => \$FlagOther );
        $cLength-> configure( -state => 'disabled' );        
        $FlagLength = 0;
        $cLength-> configure( -variable => \$FlagLength );
        }
    
    else {
        #-- concatenation et extraction --- 
        $Label10 -> configure(-fg => "#36648B");
        $Label11 -> configure(-fg => "#36648B");
        $tSpe -> configure(-state => 'normal');
        $bSpe -> configure(-state => 'active', -bg => "#DCDCDC");
        $tMinLen -> configure(-state => 'normal');
        $NameFile = "";
        $Label20 -> configure(-fg => 'darkgrey');
        $tTax -> configure(-state => 'disabled', -textvariable => \$NameFile);
        $bTax -> configure(-state => 'disabled');
        $TauxMin = "";
        $Label21 -> configure(-fg => 'darkgrey');
        $Label22 -> configure(-fg => 'darkgrey');
        $tFrq -> configure(-state => 'disabled', -textvariable => \$TauxMin);
        if ( $Step == 2 ) {
            #-- concatenation ---
            $cChim -> configure(-state => 'active', -bg => "#DCDCDC");
            $rSelDist -> configure(-state => 'active', -bg => "#DCDCDC");
            $rSelLgr -> configure(-state => 'active', -bg => "#DCDCDC");
            ActiveSaisieDist($Select);
            $cDirGrp -> configure(-state => 'active', -bg => "#DCDCDC");
            $cDirSit -> configure(-state => 'active', -bg => "#DCDCDC");
            ActiveSaisieSub(1);
            $Label50 -> configure(-fg => "#4169E1");
            $tMisPos -> configure(-state => 'normal');
            $cTreePs -> configure(-state => 'active', -bg => "#DCDCDC");
            $cCmp -> configure(-state => 'active', -bg => "#DCDCDC");
            #-- extraction ---
            $rOnly -> configure(-state => 'disabled');
            $rLeast -> configure(-state => 'disabled');
            $rAll -> configure(-state => 'disabled');
            #-- format de sortie ---
            $rSpec-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $rAlpha-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cFasta-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cMust-> configure(-state => 'active', -bg => "#DCDCDC" );
            $cPHYLIP-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cNexus-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cMrB-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cPAUP-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cOther-> configure(-state => 'active', -bg => "#DCDCDC" );        
            $cLength-> configure(-state => 'active', -bg => "#DCDCDC" );
            }
        else {
            #-- extraction ---
            $cChim -> configure(-state => 'disabled');
            $rSelDist -> configure(-state => 'disabled');
            $rSelLgr -> configure(-state => 'disabled');
            ActiveSaisieDist(2);
            $cDirGrp -> configure(-state => 'disabled');
            $cDirSit -> configure(-state => 'disabled');
            ActiveSaisieSub(0);
            $Label50 -> configure(-fg => 'darkgrey');
            $tMisPos -> configure(-state => 'disabled');
            $cTreePs -> configure(-state => 'disabled');
            $cCmp -> configure(-state => 'disabled');
            #-- extraction ---
            $rOnly -> configure(-state => 'active');
            $rLeast -> configure(-state => 'active');
            $rAll -> configure(-state => 'active');
            #-- format de sortie ---
            $rSpec-> configure(-state => 'disabled' );        
            $rAlpha-> configure(-state => 'disabled' );        
            $FlagAlphabet = 1;        
            $cFasta-> configure(-state => 'disabled' );
            $FlagFasta = 0;
            $cFasta-> configure(-variable => \$FlagFasta );
            $cMust-> configure(-state => 'disabled' );
            $FlagMust = 0;
            $cMust-> configure(-variable => \$FlagMust );
            $cPHYLIP-> configure(-state => 'disabled' );        
            $FlagPHYLIP = 0;
            $cPHYLIP-> configure(-variable => \$FlagPHYLIP );
            $cNexus-> configure(-state => 'disabled' );        
            $FlagNexus = 0;
            $cNexus-> configure(-variable => \$FlagNexus );
            $cMrB-> configure(-state => 'disabled' );        
            $FlagMB = 0;
            $cMrB-> configure(-variable => \$FlagMB );
            $cPAUP-> configure(-state => 'disabled' );        
            $FlagPAUP = 0;
            $cPAUP-> configure(-variable => \$FlagPAUP );
            $cOther-> configure(-state => 'disabled' );        
            $FlagOther = 0;
            $cOther-> configure(-variable => \$FlagOther );
            $cLength-> configure(-state => 'disabled' );        
            $FlagLength = 0;
            $cLength-> configure(-variable => \$FlagLength );
            }
        }
}


# DESCRIPTION : gestion de l'affichage des controles pour la creation de sous-repertoires de sequences partielles
sub ActiveSaisieSub {
    my ($flag) = @_;
    
    if ( $flag == 0 ) {
        $tDirGrp -> configure(-state => 'disabled');
        $Label40 -> configure(-fg => 'darkgrey');
        $tDirSit -> configure(-state => 'disabled');
        $Label41 -> configure(-fg => 'darkgrey');
        $Label42 -> configure(-fg => 'darkgrey');
        $tStepDir -> configure(-state => 'disabled');
        }
    else {
        if ( $FlagMisGrp == 1 )
            { $tDirGrp -> configure(-state => 'normal'); }
        else
            { $tDirGrp -> configure(-state => 'disabled'); }
        if ( $FlagMisSit == 1 ) {
            $Label40 -> configure(-fg => "#4169E1");
            $Label41 -> configure(-fg => "#4169E1");
            $Label42 -> configure(-fg => "#4169E1");
            $tDirSit -> configure(-state => 'normal');
            $tStepDir -> configure(-state => 'normal');
            }
        else {
            $Label40 -> configure(-fg => 'darkgrey');
            $tDirSit -> configure(-state => 'disabled');
            $Label41 -> configure(-fg => 'darkgrey');
            $Label42 -> configure(-fg => 'darkgrey');
            $tStepDir -> configure(-state => 'disabled');
            }
        }
}


# DESCRIPTION : gestion de l'affichage des controles pour le choix du critere de selection de la sequence
sub ActiveSaisieDist {
    my ($flag) = @_;
    if ( $flag == 1 ) {
        $cGamma -> configure(-state => 'active', -bg => "#DCDCDC");
        $Label30 -> configure(-fg => "#4169E1");
        $tSelDist -> configure(-state => 'normal' );
        $cDefSeq -> configure(-state => 'active', -bg => "#DCDCDC");
        $cAutoSeq -> configure(-state => 'active', -bg => "#DCDCDC");
        $cRemoveAll -> configure(-state => 'active', -bg => "#DCDCDC");
        }
    elsif ( $flag == 2 ) {
        $cGamma -> configure(-state => 'disabled');
        $cGamma -> deselect;
        $Label30 -> configure(-fg => 'darkgrey');
        $tSelDist -> configure(-state => 'disabled' );
        $cDefSeq -> deselect;
        $cDefSeq -> configure(-state => 'disabled');
        $cAutoSeq -> deselect;
        $cAutoSeq -> configure(-state => 'disabled');
        $cRemoveAll -> deselect;
        $cRemoveAll -> configure(-state => 'disabled');
        }
    ActiveSaisieDef($flag);
}


# DESCRIPTION : gestion de l'affichage du choix automatique de la sequence par defaut
sub ActiveSaisieDef {
    my ($flag) = @_;
    if ( $FlagDef == 1 ) {
        $cAutoSeq -> configure(-state => 'active', -bg => "#DCDCDC");
        $cRemoveAll -> deselect;
        $cRemoveAll -> configure(-state => 'disabled');
        }
    else {
        $cAutoSeq -> deselect;
        $cAutoSeq -> configure(-state => 'disabled');
        if ( $flag == 2 ) {
            $cRemoveAll -> deselect;
            $cRemoveAll -> configure(-state => 'disabled');
            }
        else
            { $cRemoveAll -> configure(-state => 'active', -bg => "#DCDCDC"); }
        }
}

################################################################
# DESCRIPTION : Visualisation de l'aide
sub ViewHelp {
    my $wHelp = $top -> Toplevel(-title => ' Help on ScaFos');
    $wHelp -> minsize( qw(500 450) );
    my $f1 = $wHelp -> Frame() -> pack(-fill => 'both');
    my $Help = $f1 -> Scrolled('Text', -scrollbars => 'e', -height => 45, -width => 90,
                                -bg => "#F5F5F5", -fg => "#800080", -font => "{arial} 10 {bold}" )
                                -> pack(-fill => 'both', -expand => 1);
    
    my $buf = "\n DESCRIPTION\n";
    $buf .= "    Selection, Concatenation and Fusion of Sequences from files of aligned sequences\n";
    $buf .= "    version: $VERSION ($DateVers)\n";
    $buf .= "\n NEEDED OPTIONS FOR ALL STEPS : \n";
    $buf .= "    Input directory: directory with aligned files\n";
    $buf .= "    Output directory: directory where output will be writen\n";
    $buf .= "\n TO MAKE OTUs FILES\n";
    $buf .= " ---------------------------\n";
    $buf .= "    This is the first step to use SCaFos.\n";
    $buf .= "    Choose radiobutton SPECIES PRESENCE.\n";
    $buf .= "    Software will create 3 files with different species within aligned files:\n";
    $buf .= "       - by frequency order of the specie in all files,\n";
    $buf .= "       - by alphabetic order of species,\n";
    $buf .= "       - by taxa order if systematic file is provided.\n";
    $buf .= "    After that you could modify species files to select species of interest and to create OTUs \n";
    $buf .= "    with several species.\n";
    $buf .= "    The line format of OTUs file is:\n";
    $buf .= "       OTU name : species1 name, species2 name, ...\n";
    $buf .= "\n TO CONCATENATE ALIGNED FILES\n";
    $buf .= " ------------------------------------------\n";
    $buf .= "    Choose radiobutton DATASETS ASSEMBLING.\n";
    $buf .= "    When MAKING of CHIMERA is choosen, if no complete sequence exists for an OTU, a new sequence \n";
    $buf .= "    is created with portion of different species within the OTU.\n";
    $buf .= "    By default, within the complete sequences, the sequence with the smaller distance of divergence \n";
    $buf .= "    according to all sequences is selected.\n";
    $buf .= "    For each OTU, you may specify the selected species in a default file (*.def). If no default\n";
    $buf .= "    species is defined or if selection is ambiguous, the user must specify the default species.\n";
    $buf .= "    In ambiguous cases, you may force SCaFos to selected the less divergent species by selecting\n";
    $buf .= "    the corresponding option.\n";
    $buf .= "    To increase the speed of ScaFos you may select sequences according to their length.\n";
    $buf .= "    For others options of concatenation, see the online help\n";
    $buf .= "\n TO SELECT FILES WITH CHOOSEN SPECIES\n";
    $buf .= " ------------------------------------------------------\n";
    $buf .= "    Choose radiobutton FILE SELECTION.\n";
    $buf .= "    According to the selected option, selected files are writen in output directory.\n";
    $buf .= "    3 options are available :\n";
    $buf .= "       - writing of new files with ONLY the sequences of species defined in species file\n";
    $buf .= "       - copying aligned files that contain AT LEAST ONE species defined in species file\n";
    $buf .= "       - copying files that contain at least one species for each OTU defined in species file\n";
    $Help -> insert('end', $buf);
    
    my $f2 = $wHelp -> Frame() -> pack(-fill => 'both', -side => 'bottom');
    $f2 -> Button ( -text => ' ONLINE HELP ', -command => \&HTMLHelp, -fg => "#228B22", -font => "{Arial} 12 {bold}")
                    -> pack(-side => 'left', -fill => 'x', -expand => 1);
    $f2 -> Button ( -text => ' CLOSE ', -command => sub { $wHelp -> destroy(); }, -fg => 'blue', -font => "{Arial} 12 {bold}")
                    -> pack(-side => 'right', -fill=> 'x', -expand => 1);
    $FenCur = $wHelp;
    $wHelp -> raise();
    $FenCur = $top;
}


sub HTMLHelp{
    my $buf = "http://megasun.bch.umontreal.ca/Software/scafos/scafos_help_gra.html";
    if ( $^O eq "MSWin32" )
        { system('"c:\Program Files\Internet Explorer\iexplore.exe" '.$buf); }
    else
        { system("mozilla $buf"); }
}


################################################################
### Verification saisie                                      ###

# NOM : CheckParam
# DESCRIPTION : gestion des parametres saisi par l'utilisateur
# PARAMETRES : so
# RETOUR : so
sub CheckParam {
    #-- Reinitialisation des variables -------------------------
    %Fichiers = ();   # hachage des fichiers .ali (fichier => especes)
    %FicLen = ();     # hachage des fichiers .ali (fichier => longueur max)
    $NbFileAli = 0;   # nombre de fichiers
    %FreqSpec = ();   # hachage des especes (espece => frequence de presence)
    $NbEspTot = 0;    # nombre d'especes initial
    $nbSpe = 0;       # nombre d'especes retenues
    %hGrp = ();       # hachage des groupes attendus par utilisateur
    %hGrpSpe = ();    # hachage des groupes
    %hCorres = ();    # hachage de correspondance
    %hSeqFile = ();   # hachage des groupes par fichiers ALI
    %hIdent = ();     # correspondance Ident sequence <=> ordre dans .puz
    %hIdentGrp = ();  # correspondance Nom de groupe <=> [ Ident grooupe, rang dans .otu ]
    %hSeqChim = ();   # hachage des chimeres par fichiers ALI
    $lSeqDef = "";    # liste des sequences par defaut
    %hSeqDef = ();    # hachage des sequences par defaut ( seq => sequences du groupe )
    %hStatFic = ();   # statistiques sur les fichiers
    %hStatGrp = ();   # statistiques sur les groupes
    %hGrpFic = ();    # % de trous par groupe pour un fichier
    %hNameChim = ();  # hachage des chimeres par fichiers ALI
    @Resume = ();
    $FlagCat = 0;     # Drapeau pour concatenation des sequences
    $FlagFile = 0;    # Drapeau pour copie fichiers avec au moins 1 espece selectionnee
    $FlagAll = 0;     # Drapeau pour copie fichiers avec toutes les especes selectionnees
    $FlagOnly = 0;    # Drapeau pour ecriture fichiers avec uniquement les especes selectionnees
    $TypeAli = '';    # format des fichiers d'entree
    $TypeSeq = '';    # protein ou ADN/ARN
    
    #-- repertoires d'entree / sortie --------------------------
    $FileRep =~ s/^(\s+)//;
    $FileRep =~ s/(\s+)$//;
    if ( $FileRep eq '' )
        { return(ViewInfo('Warning', 'Input directory is necessary !', 'blue')); }
    else {
#        if ( $FileRep !~ /$SepDir$/ ) { $FileRep .= "$SepDir"; }      # 4.40   
        if ( substr($FileRep, length($FileRep)-1) ne $SepDir ) { $FileRep .= $SepDir; }
        $In -> configure( -textvariable => \$FileRep );
        }
           
#    $CefRep .= $SepDir;
#    $CefRep =~ s/$SepDir$SepDir/$SepDir/;
    $CefRep =~ s/^(\s+)//;
    $CefRep =~ s/(\s+)$//;
    if ( substr($CefRep, length($CefRep)-1) ne $SepDir ) { $CefRep .= $SepDir; }
    $Out -> configure( -textvariable => \$CefRep );
    # test existance du repertoire de sortie
    my $flag = 1;
    while ( $flag == 1 ) { $flag = ViewTestOut(); }
    if ( $flag == -1 ) { return(-1); }
    $Out -> configure( -textvariable => \$CefRep );
    # cancel
    if ( $CefRep eq '' ) { return(-1); }
    
    $NameCef = Get_NameCef($CefRep);
    $PuzRep = $CefRep.'puz'.$SepDir;
    $MisGenRep = $CefRep.'misgen'.$SepDir;
    $MisSitRep = $CefRep.'missit'.$SepDir;

    $SpecFile = $tSpe->get();
    $MinLen = $tMinLen->get();
    if ( $MinLen eq '' ) {
        $MinLen = 0;
        $tMinLen -> configure(-textvariable => \$MinLen);
        }
    elsif ( !($MinLen =~ m/\d*/) )
        { return(ViewInfo('Warning', 'Percent of sequence length is an integer value between 0 and 100 !', 'blue')); }
    elsif ( ($MinLen < 0) or ($MinLen > 100) )
        { return(ViewInfo('Warning', 'Percent of sequence length is an integer value between 0 and 100 !', 'blue')); }
    
    #-- creation du fichier .otu -------------------------------
    if ( $Step == 1 ) {
        $NameFile = $tTax->get();
        if ( $TauxMin eq '' ) { $TauxMin = 0; }
        }

    #-- concatenation des sequences ----------------------------
    elsif ( $Step == 2 ) {
        if ( $SpecFile eq '' )
            { return(ViewInfo('Warning', 'With selected options FILE of SPECIES is necessary !', 'blue')); }
        $FlagCat = 1;
        if ( $TauxMin eq '' ) { $TauxMin = 0; }
        
        $FlagNoPuz = $Select - 1;
        if ( $FlagNoPuz == 1 ) {
            $FlagDef = 0;
            $FlagDefAuto = 0;
            $FlagGamma = 0;
            }
        
        else {
            if ( ($FlagDefAuto == 1) and ($FlagDef == 0) )
                { return(ViewInfo('Warning', "Automatic selection must be used with Default sequence option !", 'blue')); }
            }

        if ( ($MissPos < 0) or ($MissPos > 50) )
            { return(ViewInfo('Warning', "Percent of missing sites is an integer value between 0 and 50 !", 'blue')); }
        if ( $FlagMisSit == 0 ) 
            { $PctMisSit = -1; }
        else {
            if ( ($PctMisSit < 0) or ($PctMisSit > 50) )
                { return(ViewInfo('Warning', "Max percent of missing sites in subdirectories !", 'blue')); }
            if ( $PasMisSit < 1 and  $PasMisSit > $PctMisSit )
                { return(ViewInfo('Warning', "Step of missing sites is an integer value between 1 and max percent of missing sites !", 'blue')); }
            else {
                if ( ($PctMisSit % $PasMisSit) != 0 )
                    { return(ViewInfo('Warning', "Max percent of missing sites must be divided by step of missing sites", 'blue')); }
                }
            }
                    
        if ( $FlagMB == 1 or $FlagPAUP == 1 or $FlagOther == 1 ) { $FlagNexus = 1; }
        
        $PctAve /= 100;
        }
    
    #-- selection de fichiers ----------------------------------
    elsif ( $Step == 3 ) {
        if ( $SpecFile eq '' )
            { return(ViewInfo('Warning', 'With selected options FILE of SPECIES is necessary !', 'blue')); }
        if ( $File == 0 )
            { return(ViewInfo('Warning', 'You must choose type of output files !', 'blue')); }
        elsif ( $File == 1 ) { $FlagOnly = 1; }
        elsif ( $File == 2 ) { $FlagFile = 1; }
        elsif ( $File == 3 ) { $FlagAll = 1; }
        }
        
    #-- pas de selection du type d'action ----------------------
    else
        { return(ViewInfo('Warning', 'You must choose an action (SPECIES / FILES / DATASETS) !', 'blue')); }

    if ( $NbMisGrp eq '' ) { $NbMisGrp = -1; }
#print "TauxMin=$TauxMin\tPctAve=$PctAve\tFlagCat=$FlagCat\tFlagChim=$FlagChim\n";
#print "FlagNoPuz=$FlagNoPuz\tFlagDef=$FlagDef\tFlagDefAuto=$FlagDefAuto\t\n";
#print "FlagGamma = $FlagGamma\n";
        
    LoadCEF();
}


# NOM : ViewTestOut 
# DESCRIPTION : test si le repertoire de sortie existe deja
# PARAMETRES : so
# RETOUR : so
sub ViewTestOut {
    my ( $reponse , $bd , $tDir );
    my $Dir = $CefRep;
    
    if ( UnconvenientOut($Dir) == -1 ) { return(-1); }
        
    # repertoire existant
    my $Rep = getcwd();
    my $flag = 0;
    my @T1;
    my $F;
    
    if ( chdir $Dir ) {
        chdir $Rep;
        
        $bd = $top -> DialogBox ( -title => 'Output directory' ,
                                  -buttons => [ 'Create New', 'Overwrite', '  Cancel  ' ]);
        $bd -> add ( 'Label', -text => "\n$Dir already exists. Do you want overwrite it ?", -fg => 'blue',
                              -font => "{Arial} ".sprintf("%.0f", 10*$Scale)." {bold}")
                   -> pack( -side => 'top', -padx => 10);
        $bd -> add ( 'Label', -text => 'New directory', -fg => "#36648B",
                              -font => "{Arial} ".sprintf("%.0f", 10*$Scale)." {bold}")
                   -> pack(-side => 'left', -padx => 10);

        $tDir = $bd -> add ( 'Entry', -textvariable => \$Dir, -fg => "#003F87", -font => "{Arial} ".sprintf("%.0f", 10*$Scale)." {bold}");
        $tDir -> pack( -side => 'top', -fill => 'x', -expand => 1, -pady => 20, -padx => 10) ;
        $tDir -> focusForce();
        $FenCur = $bd;
        $reponse = $bd -> Show ( ) ;
        if ( $reponse eq 'Create New' ) {
            if ( substr($Dir, length($Dir)-1) ne $SepDir ) { $Dir .= $SepDir; }
            if ( UnconvenientOut($Dir) == -1 ) { return(-1); }
            $CefRep = $Dir; 
            $flag = 1;
            }
        elsif ( $reponse eq 'Overwrite' )
            { RemoveDir($CefRep); }
        elsif ( $reponse eq '  Cancel  ' )
            { $CefRep = ""; } 
        }
    $FenCur = $top;
    return($flag);
}


1;

### fin du fichier                                           ###
################################################################
